{
  Fixed some bugs. Copyright (C) V Kulimov, 1996 year.
  e-mail: root@sevnb.komi.su
  FidoNet: 2:5003/20
}

Unit
  FindFile;
{$R-}
Interface

Uses Dos;

Type
  FileProc = Procedure(X: PathStr);

Procedure FindFiles (DirPath : PathStr;      (* initial path           *)
                     Mask : String;          (* mask to look For       *)
                     Recurse : Boolean;      (* recurse into sub-dirs? *)
                     FileDoer : FileProc);   (* what to do With found  *)

(* Starting at <DirPath>, FindFiles will pass the path of all the Files
   it finds that match <Mask> to the <FileDoer> Procedure.  if <Recurse>
   is True, all such Files in subdirectories beneath <DirPath> will be
   visited as well.  if <Recurse> is False, the names of subdirectories
   in <DirPath> will be passed as well. *)

Implementation

Procedure FindFiles (DirPath  : PathStr;      (* initial path           *)
                     Mask     : String;          (* mask to look For       *)
                     Recurse  : Boolean;      (* recurse into sub-dirs? *)
                     FileDoer : FileProc);   (* what to do With found  *)

  Procedure SubVisit(DirPath: PathStr);
  Var
    Looking4 : SearchRec;
  Begin
    FindFirst(Concat(DirPath, Mask), AnyFile, looking4);
    While DosError = 0 do
    Begin
      if looking4.attr and (VolumeID + Directory) = 0 then
         FileDoer(Concat(DirPath, looking4.name));
      FindNext(Looking4);
    End;   (* While *)

    if Recurse then
    Begin
      FindFirst(Concat(DirPath, '*.*' ), AnyFile, looking4);
      While (DosError = 0) and ((looking4.name[1] = '.') or (Looking4.Attr = VolumeID)) do
        FindNext(looking4);   (* skip . and .. directories *)

      While (DosError = 0) do
      Begin
        if ((looking4.attr and Directory) = Directory) then
           SubVisit(Concat( DirPath, looking4.name, '\'));
        FindNext ( Looking4 );
      End;   (* While *)
    End;   (* if recursing *)

  End;   (* SubVisit *)

Begin   (* FindFiles *)
  SubVisit(DirPath);
End;   (* FindFiles *)

End.

