Unit
   ScrollB;

Interface

Uses
  Dialogs, Objects, Drivers, Views;

Type
  PScrollLB = ^TScrollLB;
  TScrollLB = object(TListBox)
    Constructor Init(var Bounds: TRect; ANumCols: Word; AHSBar, AVSBar:
                     PScrollBar; StrLength: Byte);
    Procedure HandleEvent(var Event: TEvent); Virtual;
  End;

  PCommandScrollLB = ^TCommandScrollLB;
  TCommandScrollLB = Object(TScrollLB)
    xCommand: Word;
    Constructor Init(var Bounds: TRect; ANumCols: Word; AHSBar, AVSBar:
                     PScrollBar; StrLength: Byte; ACommand: Word);
    Procedure SelectItem(Item: Integer); Virtual;
    Procedure HandleEvent(var Event: TEvent); Virtual;
  End;


Implementation

Constructor TScrollLB.Init(var Bounds: TRect; ANumCols: Word;
                           AHSBar, AVSBar: PScrollBar; StrLength: Byte);
Begin
  if Not TListViewer.Init(Bounds, ANumCols, AHSBar, AVSBar) then
     Fail;
  SetRange(0);
  if HScrollBar <> Nil then
     HScrollBar^.SetRange(1, StrLength + 1);
End;

Procedure TScrollLB.HandleEvent(var Event: TEvent);
Begin
  Case Event.What of
    evKeyDown: Case Event.KeyCode of
                 kbLeft, kbRight,
                 kbHome, kbEnd:  HScrollBar^.HandleEvent(Event);
               End;
  End;
  Inherited HandleEvent(Event);
End;


{ TCommandLB Object }
Constructor TCommandScrollLB.Init;
Begin
  Inherited Init(Bounds,ANumCols,AHSBar, AVSBar, StrLength);
  xCommand := ACommand;
End;

procedure TCommandScrollLB.SelectItem(Item: Integer);
var
  E: TEvent;
begin
  inherited SelectItem(Item);
  with E do
  begin
    What := evCommand;
    Command := xCommand;
    InfoPtr := nil;
  end;
  PutEvent(E);
end;

Procedure TCommandScrollLB.HandleEvent;
Begin
  if Event.What = evKeyDown then
  if Event.KeyCode = kbEnter then
     Message(Owner, evCommand, xCommand, Nil);
  Inherited HandleEvent(Event);
End;

End.
